diff -r -u -H -N gcc-2.6.3/cp/parse.c gcc-i2.6.3/cp/parse.c
--- gcc-2.6.3/cp/parse.c	Fri Oct 14 14:51:23 1994
+++ gcc-i2.6.3/cp/parse.c	Tue Dec 20 16:53:24 1994
@@ -3143,43 +3091,60 @@
     -1,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
     33,    -1,    35,    -1,    37,    38,    -1,    40,    41,    42,
     43,    -1,    -1,    46,    47,    48,    49,    50,    51,    -1,
-    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,
-    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
-    73,    74,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,
-    83,    -1,    -1,     3,     4,    88,     6,     7,     8,     9,
-    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
-    -1,   104,    -1,    -1,    -1,    -1,    -1,    27,    28,    -1,
-    -1,    31,    -1,    33,    -1,    35,    -1,    37,    38,    -1,
-    40,    41,    42,    43,    -1,    -1,    46,    47,    48,    49,
-    50,    51,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
-    -1,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,
-    -1,    -1,    -1,    73,    74,    75,    -1,    -1,    -1,    -1,
-    -1,    81,    82,    83,    -1,    -1,     3,     4,    88,     6,
-     7,     8,     9,    -1,    11,    12,    -1,    -1,    -1,    -1,
-    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,
-    27,    28,    -1,    -1,    31,    -1,    33,    -1,    35,    -1,
-    37,    38,    -1,    40,    41,    42,    43,    -1,    -1,    46,
-    47,    48,    49,    50,    51,    -1,    53,    -1,    -1,    -1,
-    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    65,    -1,
-    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    -1,
-    -1,    -1,    -1,    -1,    81,    82,    83,    -1,    -1,    -1,
-    -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
-    -1,    -1,    55,    -1,    57,    58,    59,   104,    61,    62,
-    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
-    73,    74,    75,    76,    77,    78,    79,    57,    58,    59,
-    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
+    53,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
+    -1,    12,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
+     6,     7,    -1,    -1,    -1,    -1,    12,    -1,    81,    82,
+    83,    -1,    -1,    -1,    35,    88,    -1,    -1,    -1,    92,
+    41,    27,    -1,    44,    -1,    31,    -1,    -1,    -1,    35,
+    51,   104,    53,    -1,    -1,    41,    -1,    -1,    -1,    -1,
+    -1,    -1,    -1,    -1,    65,    51,    -1,    53,    -1,    -1,
+    56,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    65,
+    -1,    -1,    83,    -1,    85,    -1,    -1,    88,    89,    75,
+    -1,     3,     4,     5,     6,     7,    -1,    83,    10,    -1,
+    12,    -1,    88,    -1,    -1,    -1,    -1,    -1,     3,     4,
+     5,     6,     7,    -1,    -1,    27,    -1,    12,    -1,    31,
+    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    41,
+    -1,    -1,    27,    -1,    -1,    -1,    31,    -1,    -1,    51,
+    35,    53,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
+    -1,    -1,    -1,    65,    -1,    -1,    51,    -1,    53,    -1,
+    -1,    -1,    -1,    75,    -1,    60,    -1,    -1,    -1,    -1,
+    65,    83,    -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,
+    75,     3,     4,     5,     6,     7,    -1,    -1,    83,    -1,
+    12,    -1,    -1,    88,    -1,    -1,    -1,    -1,     3,     4,
+     5,     6,     7,    -1,    -1,    27,    -1,    12,    -1,    31,
+    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    41,
+    -1,    -1,    27,    -1,    -1,    -1,    31,    -1,    -1,    51,
+    35,    53,    -1,    -1,    56,    -1,    41,    -1,    -1,    -1,
+    -1,    -1,     4,    65,     6,     7,    51,    -1,    53,    -1,
+    12,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
+    65,    83,    -1,    -1,    -1,    27,    88,    -1,    -1,    31,
+    75,    -1,    -1,    35,    -1,    -1,    -1,    -1,    83,    -1,
+    -1,    -1,    44,    88,    -1,    -1,    -1,    -1,    -1,    51,
+    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
+    57,    58,    59,    65,    61,    62,    63,    64,    65,    66,
+    67,    68,    69,    75,    71,    72,    73,    74,    75,    76,
+    77,    78,    79,    85,    -1,    -1,    88,    89,    57,    58,
+    59,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
+    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
+    79,    55,    32,    57,    58,    59,    -1,    61,    62,    63,
+    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
+    74,    75,    76,    77,    78,    79,   105,    57,    58,    59,
+    -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
     70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
     57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
     67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
-    77,    78,    79,    57,    58,    59,    -1,    61,    62,    63,
+    77,    78,    79,    57,    58,    59,    60,    61,    62,    63,
     64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
     74,    75,    76,    77,    78,    79,    57,    58,    59,    -1,
-    61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
+    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
     71,    72,    73,    74,    75,    76,    77,    78,    79,    59,
     -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
     70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
-    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
-    73,    74,    75,    76,    77,    78,    79
+    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
+    72,    73,    74,    75,    76,    77,    78,    79,    64,    65,
+    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
+    76,    77,    78,    79,    65,    66,    67,    68,    69,    70,
+    71,    72,    73,    74,    75,    76,    77,    78,    79
 };
 /* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
 #line 3 "/usr/local/lib/bison.simple"
@@ -3364,23 +3329,8 @@
 #endif
 
 #line 184 "/usr/local/lib/bison.simple"
-
-/* The user can define YYPARSE_PARAM as the name of an argument to be passed
-   into yyparse.  The argument should have type void *.
-   It should actually point to an object.
-   Grammar actions can access the variable by casting it
-   to the proper pointer type.  */
-
-#ifdef YYPARSE_PARAM
-#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
-#else
-#define YYPARSE_PARAM
-#define YYPARSE_PARAM_DECL
-#endif
-
 int
-yyparse(YYPARSE_PARAM)
-     YYPARSE_PARAM_DECL
+yyparse()
 {
   register int yystate;
   register int yyn;
@@ -4767,21 +4717,13 @@
 #line 1253 "parse.y"
 { yyval.ttype = build_parse_node (ADDR_EXPR, yyvsp[0].ttype); ;
     break;}
-case 228:
-#line 1255 "parse.y"
-{ yyval.ttype = yyvsp[-1].ttype; ;
-    break;}
-case 231:
-#line 1262 "parse.y"
+case 230:
+#line 1260 "parse.y"
 { push_nested_class (TREE_TYPE (OP0 (yyval.ttype)), 3);
 		  TREE_COMPLEXITY (yyval.ttype) = current_class_depth; ;
     break;}
-case 232:
-#line 1265 "parse.y"
-{ yyval.ttype = finish_decl_parsing (yyvsp[-1].ttype); ;
-    break;}
-case 233:
-#line 1270 "parse.y"
+case 231:
+#line 1266 "parse.y"
 {
 		  if (TREE_CODE (yyval.ttype) == BIT_NOT_EXPR)
 		    yyval.ttype = build_x_unary_op (BIT_NOT_EXPR, TREE_OPERAND (yyval.ttype, 0));
@@ -4801,20 +4743,20 @@
 		    yyval.ttype = do_identifier (yyval.ttype);
 		;
     break;}
-case 236:
-#line 1291 "parse.y"
+case 234:
+#line 1287 "parse.y"
 { yyval.ttype = combine_strings (yyval.ttype); ;
     break;}
-case 237:
-#line 1293 "parse.y"
+case 235:
+#line 1289 "parse.y"
 { yyval.ttype = yyvsp[-1].ttype; ;
     break;}
-case 238:
-#line 1295 "parse.y"
+case 236:
+#line 1291 "parse.y"
 { yyval.ttype = error_mark_node; ;
     break;}
-case 239:
-#line 1297 "parse.y"
+case 237:
+#line 1293 "parse.y"
 { if (current_function_decl == 0)
 		    {
 		      error ("braced-group within expression allowed only inside a function");
@@ -4823,8 +4765,8 @@
 		  keep_next_level ();
 		  yyval.ttype = expand_start_stmt_expr (); ;
     break;}
-case 240:
-#line 1305 "parse.y"
+case 238:
+#line 1301 "parse.y"
 { tree rtl_exp;
 		  if (flag_ansi)
 		    pedwarn ("ANSI C++ forbids braced-groups within expressions");
@@ -4846,16 +4788,16 @@
 		    yyval.ttype = yyvsp[-1].ttype;
 		;
     break;}
-case 241:
-#line 1326 "parse.y"
+case 239:
+#line 1322 "parse.y"
 { /* [eichin:19911016.1902EST] */
                   yyval.ttype = build_x_function_call (yyvsp[-3].ttype, yyvsp[-1].ttype, current_class_decl); 
                   /* here we instantiate_class_template as needed... */
                   do_pending_templates ();
                 ;
     break;}
-case 242:
-#line 1330 "parse.y"
+case 240:
+#line 1326 "parse.y"
 {
                   if (TREE_CODE (yyvsp[-1].ttype) == CALL_EXPR
                       && TREE_TYPE (yyvsp[-1].ttype) != void_type_node)
@@ -4864,8 +4806,8 @@
                     yyval.ttype = yyvsp[-1].ttype;
                 ;
     break;}
-case 243:
-#line 1338 "parse.y"
+case 241:
+#line 1334 "parse.y"
 {
 		  yyval.ttype = build_x_function_call (yyval.ttype, NULL_TREE, current_class_decl);
 		  if (TREE_CODE (yyval.ttype) == CALL_EXPR
@@ -4873,12 +4815,12 @@
 		    yyval.ttype = require_complete_type (yyval.ttype);
                 ;
     break;}
-case 244:
-#line 1345 "parse.y"
+case 242:
+#line 1341 "parse.y"
 { yyval.ttype = grok_array_decl (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
-case 245:
-#line 1347 "parse.y"
+case 243:
+#line 1343 "parse.y"
 { /* If we get an OFFSET_REF, turn it into what it really
 		     means (e.g., a COMPONENT_REF).  This way if we've got,
 		     say, a reference to a static member that's being operated
@@ -4888,14 +4830,14 @@
 		    yyval.ttype = resolve_offset_ref (yyval.ttype);
 		  yyval.ttype = build_x_unary_op (POSTINCREMENT_EXPR, yyval.ttype); ;
     break;}
-case 246:
-#line 1356 "parse.y"
+case 244:
+#line 1352 "parse.y"
 { if (TREE_CODE (yyval.ttype) == OFFSET_REF)
 		    yyval.ttype = resolve_offset_ref (yyval.ttype);
 		  yyval.ttype = build_x_unary_op (POSTDECREMENT_EXPR, yyval.ttype); ;
     break;}
-case 247:
-#line 1361 "parse.y"
+case 245:
+#line 1357 "parse.y"
 { if (current_class_decl)
 		    {
 #ifdef WARNING_ABOUT_CCD
@@ -4919,8 +4861,8 @@
 		    }
 		;
     break;}
-case 248:
-#line 1384 "parse.y"
+case 246:
+#line 1380 "parse.y"
 {
 		  tree type;
 		  tree id = yyval.ttype;
@@ -4965,37 +4907,37 @@
 		    }
 		;
     break;}
-case 250:
-#line 1429 "parse.y"
+case 248:
+#line 1425 "parse.y"
 { tree type = groktypename (yyvsp[-4].ttype);
 		  yyval.ttype = build_dynamic_cast (type, yyvsp[-1].ttype); ;
     break;}
-case 251:
-#line 1432 "parse.y"
+case 249:
+#line 1428 "parse.y"
 { tree type = groktypename (yyvsp[-4].ttype);
 		  yyval.ttype = build_static_cast (type, yyvsp[-1].ttype); ;
     break;}
-case 252:
-#line 1435 "parse.y"
+case 250:
+#line 1431 "parse.y"
 { tree type = groktypename (yyvsp[-4].ttype);
 		  yyval.ttype = build_reinterpret_cast (type, yyvsp[-1].ttype); ;
     break;}
-case 253:
-#line 1438 "parse.y"
+case 251:
+#line 1434 "parse.y"
 { tree type = groktypename (yyvsp[-4].ttype);
 		  yyval.ttype = build_const_cast (type, yyvsp[-1].ttype); ;
     break;}
-case 254:
-#line 1441 "parse.y"
+case 252:
+#line 1437 "parse.y"
 { yyval.ttype = build_typeid (yyvsp[-1].ttype); ;
     break;}
-case 255:
-#line 1443 "parse.y"
+case 253:
+#line 1439 "parse.y"
 { tree type = groktypename (yyvsp[-1].ttype);
 		  yyval.ttype = get_typeid (type); ;
     break;}
-case 256:
-#line 1446 "parse.y"
+case 254:
+#line 1442 "parse.y"
 {
 		do_scoped_id:
 		  yyval.ttype = IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype);
@@ -5035,8 +4977,8 @@
 
 		;
     break;}
-case 257:
-#line 1485 "parse.y"
+case 255:
+#line 1481 "parse.y"
 {
 		  got_scope = NULL_TREE;
 		  if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
@@ -5044,28 +4986,28 @@
 		  yyval.ttype = yyvsp[0].ttype;
 		;
     break;}
+case 256:
+#line 1488 "parse.y"
+{ yyval.ttype = build_offset_ref (OP0 (yyval.ttype), OP1 (yyval.ttype)); ;
+    break;}
+case 257:
+#line 1490 "parse.y"
+{ yyval.ttype = build_member_call (OP0 (yyval.ttype), OP1 (yyval.ttype), yyvsp[-1].ttype); ;
+    break;}
 case 258:
 #line 1492 "parse.y"
-{ yyval.ttype = build_offset_ref (OP0 (yyval.ttype), OP1 (yyval.ttype)); ;
+{ yyval.ttype = build_member_call (OP0 (yyval.ttype), OP1 (yyval.ttype), NULL_TREE); ;
     break;}
 case 259:
 #line 1494 "parse.y"
-{ yyval.ttype = build_member_call (OP0 (yyval.ttype), OP1 (yyval.ttype), yyvsp[-1].ttype); ;
+{ yyval.ttype = build_component_ref (yyval.ttype, yyvsp[0].ttype, NULL_TREE, 1); ;
     break;}
 case 260:
 #line 1496 "parse.y"
-{ yyval.ttype = build_member_call (OP0 (yyval.ttype), OP1 (yyval.ttype), NULL_TREE); ;
+{ yyval.ttype = build_object_ref (yyval.ttype, OP0 (yyvsp[0].ttype), OP1 (yyvsp[0].ttype)); ;
     break;}
 case 261:
 #line 1498 "parse.y"
-{ yyval.ttype = build_component_ref (yyval.ttype, yyvsp[0].ttype, NULL_TREE, 1); ;
-    break;}
-case 262:
-#line 1500 "parse.y"
-{ yyval.ttype = build_object_ref (yyval.ttype, OP0 (yyvsp[0].ttype), OP1 (yyvsp[0].ttype)); ;
-    break;}
-case 263:
-#line 1502 "parse.y"
 {
 #if 0
 		  /* This is a future direction of this code, but because
@@ -5081,8 +5023,8 @@
 #endif
 		;
     break;}
-case 264:
-#line 1517 "parse.y"
+case 262:
+#line 1513 "parse.y"
 {
 #if 0
 		  /* This is a future direction of this code, but because
@@ -5098,8 +5040,8 @@
 #endif
 		;
     break;}
-case 265:
-#line 1532 "parse.y"
+case 263:
+#line 1528 "parse.y"
 {
 		  if (IS_SIGNATURE (IDENTIFIER_TYPE_VALUE (OP0 (yyvsp[-3].ttype))))
 		    {
@@ -5111,8 +5053,8 @@
 		    yyval.ttype = build_scoped_method_call (yyval.ttype, OP0 (yyvsp[-3].ttype), OP1 (yyvsp[-3].ttype), yyvsp[-1].ttype);
 		;
     break;}
-case 266:
-#line 1543 "parse.y"
+case 264:
+#line 1539 "parse.y"
 {
 		  if (IS_SIGNATURE (IDENTIFIER_TYPE_VALUE (OP0 (yyvsp[-1].ttype))))
 		    {
@@ -5124,8 +5066,8 @@
 		    yyval.ttype = build_scoped_method_call (yyval.ttype, OP0 (yyvsp[-1].ttype), OP1 (yyvsp[-1].ttype), NULL_TREE);
 		;
     break;}
-case 267:
-#line 1555 "parse.y"
+case 265:
+#line 1551 "parse.y"
 { 
 		  if (TREE_CODE (TREE_TYPE (yyvsp[-3].ttype)) 
 		      != TREE_CODE (TREE_TYPE (IDENTIFIER_GLOBAL_VALUE (yyvsp[-1].ttype))))
@@ -5133,8 +5075,8 @@
 		  yyval.ttype = convert (void_type_node, yyvsp[-3].ttype);
 		;
     break;}
-case 268:
-#line 1562 "parse.y"
+case 266:
+#line 1558 "parse.y"
 { 
 		  if (yyvsp[-4].ttype != yyvsp[-1].ttype)
 		    cp_error ("destructor specifier `%T::~%T()' must have matching names", yyvsp[-4].ttype, yyvsp[-1].ttype);
@@ -5144,36 +5086,36 @@
 		  yyval.ttype = convert (void_type_node, yyvsp[-5].ttype);
 		;
     break;}
-case 269:
-#line 1611 "parse.y"
+case 267:
+#line 1607 "parse.y"
 { yyval.itype = 0; ;
     break;}
-case 270:
-#line 1613 "parse.y"
+case 268:
+#line 1609 "parse.y"
 { got_scope = NULL_TREE; yyval.itype = 1; ;
     break;}
-case 271:
-#line 1617 "parse.y"
+case 269:
+#line 1613 "parse.y"
 { yyval.itype = 0; ;
     break;}
-case 272:
-#line 1619 "parse.y"
+case 270:
+#line 1615 "parse.y"
 { got_scope = NULL_TREE; yyval.itype = 1; ;
     break;}
-case 273:
-#line 1624 "parse.y"
+case 271:
+#line 1620 "parse.y"
 { yyval.ttype = true_node; ;
     break;}
-case 274:
-#line 1626 "parse.y"
+case 272:
+#line 1622 "parse.y"
 { yyval.ttype = false_node; ;
     break;}
-case 276:
-#line 1633 "parse.y"
+case 274:
+#line 1629 "parse.y"
 { yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
     break;}
-case 277:
-#line 1638 "parse.y"
+case 275:
+#line 1634 "parse.y"
 {
 		  if (! current_function_parms_stored)
 		    store_parm_decls ();
@@ -5184,14 +5126,14 @@
 		  keep_next_level ();
 		;
     break;}
-case 279:
-#line 1651 "parse.y"
+case 277:
+#line 1647 "parse.y"
 {
 		  yyval.ttype = build_x_arrow (yyval.ttype);
 		;
     break;}
-case 280:
-#line 1659 "parse.y"
+case 278:
+#line 1655 "parse.y"
 { tree d = get_decl_list (yyvsp[-2].ttype);
 		  int yes = suspend_momentary ();
 		  d = start_decl (yyvsp[-1].ttype, d, 0, NULL_TREE);
@@ -5201,8 +5143,8 @@
 		    note_got_semicolon (yyvsp[-2].ttype);
 		;
     break;}
-case 281:
-#line 1668 "parse.y"
+case 279:
+#line 1664 "parse.y"
 { tree d = yyvsp[-2].ttype;
 		  int yes = suspend_momentary ();
 		  d = start_decl (yyvsp[-1].ttype, d, 0, NULL_TREE);
@@ -5211,164 +5153,164 @@
 		  note_list_got_semicolon (yyvsp[-2].ttype);
 		;
     break;}
-case 282:
-#line 1676 "parse.y"
+case 280:
+#line 1672 "parse.y"
 {
 		  resume_momentary (yyvsp[-1].itype);
 		  if (IS_AGGR_TYPE_CODE (TREE_CODE (yyvsp[-2].ttype)))
 		    note_got_semicolon (yyvsp[-2].ttype);
 		;
     break;}
-case 283:
-#line 1682 "parse.y"
+case 281:
+#line 1678 "parse.y"
 {
 		  resume_momentary (yyvsp[-1].itype);
 		  note_list_got_semicolon (yyvsp[-2].ttype);
 		;
     break;}
-case 284:
-#line 1687 "parse.y"
+case 282:
+#line 1683 "parse.y"
 { resume_momentary (yyvsp[-1].itype); ;
     break;}
-case 285:
-#line 1689 "parse.y"
+case 283:
+#line 1685 "parse.y"
 {
 		  shadow_tag (yyvsp[-1].ttype);
 		  note_list_got_semicolon (yyvsp[-1].ttype);
 		;
     break;}
-case 286:
-#line 1694 "parse.y"
+case 284:
+#line 1690 "parse.y"
 { warning ("empty declaration"); ;
     break;}
-case 289:
-#line 1708 "parse.y"
+case 287:
+#line 1704 "parse.y"
 { yyval.ttype = build_parse_node (CALL_EXPR, NULL_TREE, empty_parms (),
 					 NULL_TREE); ;
     break;}
-case 290:
-#line 1711 "parse.y"
+case 288:
+#line 1707 "parse.y"
 { yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), 
 					 NULL_TREE); ;
     break;}
+case 289:
+#line 1714 "parse.y"
+{ yyval.ttype = build_decl_list (yyval.ttype, yyvsp[0].ttype); ;
+    break;}
+case 290:
+#line 1716 "parse.y"
+{ yyval.ttype = build_decl_list (yyval.ttype, yyvsp[0].ttype); ;
+    break;}
 case 291:
 #line 1718 "parse.y"
-{ yyval.ttype = build_decl_list (yyval.ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_decl_list (get_decl_list (yyval.ttype), yyvsp[0].ttype); ;
     break;}
 case 292:
 #line 1720 "parse.y"
-{ yyval.ttype = build_decl_list (yyval.ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_decl_list (yyval.ttype, NULL_TREE); ;
     break;}
 case 293:
 #line 1722 "parse.y"
-{ yyval.ttype = build_decl_list (get_decl_list (yyval.ttype), yyvsp[0].ttype); ;
-    break;}
-case 294:
-#line 1724 "parse.y"
 { yyval.ttype = build_decl_list (yyval.ttype, NULL_TREE); ;
     break;}
-case 295:
-#line 1726 "parse.y"
-{ yyval.ttype = build_decl_list (yyval.ttype, NULL_TREE); ;
+case 296:
+#line 1735 "parse.y"
+{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
+    break;}
+case 297:
+#line 1737 "parse.y"
+{ yyval.ttype = decl_tree_cons (NULL_TREE, yyval.ttype, yyvsp[0].ttype); ;
     break;}
 case 298:
 #line 1739 "parse.y"
-{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
+{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyval.ttype)); ;
     break;}
 case 299:
 #line 1741 "parse.y"
-{ yyval.ttype = decl_tree_cons (NULL_TREE, yyval.ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyval.ttype)); ;
     break;}
 case 300:
 #line 1743 "parse.y"
-{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyval.ttype)); ;
-    break;}
-case 301:
-#line 1745 "parse.y"
-{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyval.ttype)); ;
-    break;}
-case 302:
-#line 1747 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[-2].ttype, 
 				       chainon (yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyval.ttype))); ;
     break;}
-case 303:
-#line 1753 "parse.y"
+case 301:
+#line 1749 "parse.y"
 { if (extra_warnings)
 		    warning ("`%s' is not at beginning of declaration",
 			     IDENTIFIER_POINTER (yyval.ttype));
 		  yyval.ttype = build_decl_list (NULL_TREE, yyval.ttype); ;
     break;}
-case 304:
-#line 1758 "parse.y"
+case 302:
+#line 1754 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
     break;}
-case 305:
-#line 1760 "parse.y"
+case 303:
+#line 1756 "parse.y"
 { if (extra_warnings)
 		    warning ("`%s' is not at beginning of declaration",
 			     IDENTIFIER_POINTER (yyvsp[0].ttype));
 		  yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
     break;}
-case 306:
-#line 1772 "parse.y"
+case 304:
+#line 1768 "parse.y"
 { TREE_STATIC (yyval.ttype) = 1; ;
     break;}
-case 307:
-#line 1774 "parse.y"
+case 305:
+#line 1770 "parse.y"
 { yyval.ttype = IDENTIFIER_AS_LIST (yyval.ttype); ;
     break;}
-case 308:
-#line 1776 "parse.y"
+case 306:
+#line 1772 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype);
 		  TREE_STATIC (yyval.ttype) = 1; ;
     break;}
-case 309:
-#line 1779 "parse.y"
+case 307:
+#line 1775 "parse.y"
 { if (extra_warnings && TREE_STATIC (yyval.ttype))
 		    warning ("`%s' is not at beginning of declaration",
 			     IDENTIFIER_POINTER (yyvsp[0].ttype));
 		  yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype);
 		  TREE_STATIC (yyval.ttype) = TREE_STATIC (yyvsp[-1].ttype); ;
     break;}
-case 310:
-#line 1795 "parse.y"
+case 308:
+#line 1791 "parse.y"
 { yyval.ttype = get_decl_list (yyval.ttype); ;
     break;}
-case 311:
-#line 1797 "parse.y"
+case 309:
+#line 1793 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
     break;}
-case 312:
-#line 1799 "parse.y"
+case 310:
+#line 1795 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyval.ttype, yyvsp[0].ttype); ;
     break;}
-case 313:
-#line 1801 "parse.y"
+case 311:
+#line 1797 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyval.ttype)); ;
     break;}
-case 314:
-#line 1806 "parse.y"
+case 312:
+#line 1802 "parse.y"
 { yyval.ttype = build_decl_list (NULL_TREE, yyval.ttype); ;
     break;}
-case 315:
-#line 1808 "parse.y"
+case 313:
+#line 1804 "parse.y"
 { yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
     break;}
-case 319:
-#line 1819 "parse.y"
+case 317:
+#line 1815 "parse.y"
 { yyval.ttype = TREE_TYPE (yyvsp[-1].ttype);
 		  if (flag_ansi)
 		    pedwarn ("ANSI C++ forbids `typeof'"); ;
     break;}
-case 320:
-#line 1823 "parse.y"
+case 318:
+#line 1819 "parse.y"
 { yyval.ttype = groktypename (yyvsp[-1].ttype);
 		  if (flag_ansi)
 		    pedwarn ("ANSI C++ forbids `typeof'"); ;
     break;}
-case 321:
-#line 1827 "parse.y"
+case 319:
+#line 1823 "parse.y"
 { tree type = TREE_TYPE (yyvsp[-1].ttype);
 
 		  if (IS_AGGR_TYPE (type))
@@ -5383,8 +5325,8 @@
 		    }
 		;
     break;}
-case 322:
-#line 1841 "parse.y"
+case 320:
+#line 1837 "parse.y"
 { tree type = groktypename (yyvsp[-1].ttype);
 
 		  if (IS_AGGR_TYPE (type))
@@ -5399,16 +5341,16 @@
 		    }
 		;
     break;}
-case 332:
-#line 1880 "parse.y"
+case 330:
+#line 1876 "parse.y"
 { yyval.ttype = NULL_TREE; ;
     break;}
-case 333:
-#line 1882 "parse.y"
+case 331:
+#line 1878 "parse.y"
 { if (TREE_CHAIN (yyvsp[-1].ttype)) yyvsp[-1].ttype = combine_strings (yyvsp[-1].ttype); yyval.ttype = yyvsp[-1].ttype; ;
     break;}
-case 334:
-#line 1887 "parse.y"
+case 332:
+#line 1883 "parse.y"
 { current_declspecs = yyvsp[-5].ttype;
 		  if (TREE_CODE (current_declspecs) != TREE_LIST)
 		    current_declspecs = get_decl_list (current_declspecs);
@@ -5423,13 +5365,13 @@
 		  yyval.ttype = start_decl (yyvsp[-4].ttype, current_declspecs, 1, yyvsp[-3].ttype);
 		  cplus_decl_attributes (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
-case 335:
-#line 1902 "parse.y"
+case 333:
+#line 1898 "parse.y"
 { finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype, 0);
 		  yyval.itype = yyvsp[-2].itype; ;
     break;}
-case 336:
-#line 1905 "parse.y"
+case 334:
+#line 1901 "parse.y"
 { tree d;
 		  current_declspecs = yyvsp[-4].ttype;
 		  if (TREE_CODE (current_declspecs) != TREE_LIST)
@@ -5446,35 +5388,35 @@
 		  cplus_decl_attributes (d, yyvsp[0].ttype);
 		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype, 0); ;
     break;}
-case 337:
-#line 1924 "parse.y"
+case 335:
+#line 1920 "parse.y"
 { yyval.ttype = start_decl (yyvsp[-4].ttype, current_declspecs, 1, yyvsp[-3].ttype);
 		  cplus_decl_attributes (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
-case 338:
-#line 1928 "parse.y"
+case 336:
+#line 1924 "parse.y"
 { finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype, 0); ;
     break;}
-case 339:
-#line 1930 "parse.y"
+case 337:
+#line 1926 "parse.y"
 { yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 0, yyvsp[-2].ttype);
 		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype);
 		  finish_decl (yyval.ttype, NULL_TREE, yyvsp[-1].ttype, 0); ;
     break;}
-case 340:
-#line 1937 "parse.y"
+case 338:
+#line 1933 "parse.y"
 { current_declspecs = yyvsp[-5].ttype;
 		  yyvsp[0].itype = suspend_momentary ();
 		  yyval.ttype = start_decl (yyvsp[-4].ttype, current_declspecs, 1, yyvsp[-3].ttype);
 		  cplus_decl_attributes (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
-case 341:
-#line 1943 "parse.y"
+case 339:
+#line 1939 "parse.y"
 { finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype, 0);
 		  yyval.itype = yyvsp[-2].itype; ;
     break;}
-case 342:
-#line 1946 "parse.y"
+case 340:
+#line 1942 "parse.y"
 { tree d;
 		  current_declspecs = yyvsp[-4].ttype;
 		  yyval.itype = suspend_momentary ();
@@ -5482,20 +5424,20 @@
 		  cplus_decl_attributes (d, yyvsp[0].ttype);
 		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype, 0); ;
     break;}
-case 343:
-#line 1956 "parse.y"
+case 341:
+#line 1952 "parse.y"
 { current_declspecs = NULL_TREE;
 		  yyvsp[0].itype = suspend_momentary ();
 		  yyval.ttype = start_decl (yyvsp[-4].ttype, current_declspecs, 1, yyvsp[-3].ttype);
 		  cplus_decl_attributes (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
-case 344:
-#line 1962 "parse.y"
+case 342:
+#line 1958 "parse.y"
 { finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype, 0);
 		  yyval.itype = yyvsp[-2].itype; ;
     break;}
-case 345:
-#line 1965 "parse.y"
+case 343:
+#line 1961 "parse.y"
 { tree d;
 		  current_declspecs = NULL_TREE;
 		  yyval.itype = suspend_momentary ();
